--[[
TCFT3
(c) By Plozi
Version 1.0.0

** Changelog

]]

TCFT3.CargoList = {}
TCFT3.CargoList.Timer = Timer()
TCFT3.CargoList.SelectedObjectId = nil
TCFT3.CargoList.SelectedNodeId = nil
TCFT3.CargoList.UserSelectedItem = false
TCFT3.CargoList.SortCol = 1
TCFT3.CargoList.SectorScanned = false -- did we alredy scan this sector
TCFT3.CargoList.NumCU = 0
TCFT3.CargoList.Active = false

dofile("ui/ui_cargolist.lua")

TCFT3.DisplayCargolist = function()
	if (TCFT3.CargoList.MainWindow==nil) then
		TCFT3.CargoList.CreateMainWindow()
	end
	PopupDialog(TCFT3.CargoList.MainWindow,iup.CENTER, iup.CENTER)
end

TCFT3.CargoList.ScanNext = function()
	gkinterface.GKProcessCommand("RadarNext")
	local nodeid, objectid = radar.GetRadarSelectionID()
	local tname, health, dist
--	if (objectid~=nil) and (nodeid==2) then -- we hit an object lisa not sure what nodeid will do.  rem'n it out.
	if (objectid~=nil) then -- we hit an object lisa not sure what nodeid will do.  rem'n it out.
		tname, health, dist = GetTargetInfo()
			if (tname~=nil) then
				--print("Item: "..tname.."   ObjectID: "..objectid.."   NodeID: "..nodeid)
			local name, cu = string.match(tname, "^(.+)%s%((.-)cu%)") --lisa HA! Good way to identify cargo.
			if (name~=nil) then
				--print("Item2: "..name.."  CU: "..cu)
				if (string.find(cu, "x")) then
					name = name .. " (" .. cu .. ")"
					--print("Item3: "..name)
					local x1, x2 = string.match(cu, "^(%d+)x%s(%d+)")
					cu = (tonumber(x1) * tonumber(x2)) or 0
				end
				TCFT3.CargoList.ItemList:additem( { itemname=name, distance=tonumber(dist), cargocu=tonumber(cu), objid=objectid, nodeid=nodeid} )
				TCFT3.CargoList.NumCU = TCFT3.CargoList.NumCU + tonumber(cu)
			end
		end
		--print("Starting the timer again.")
		TCFT3.CargoList.Timer:SetTimeout(3, TCFT3.CargoList.ScanNext) --Lisa change to 4ms from 3ms. No diff. back to 3 
	else -- if objectid = nil then we are done
		--if (objectid~=nil) then --lisa; we never would have got here... 
			--TCFT3.CargoList.Timer:SetTimeout(3, TCFT3.CargoList.ScanNext)
		--else
	--print("Got to the ELSE")
			TCFT3.CargoList.Active = false
			if(targetless) then targetless.api.radarlock = false end
			TCFT3.CargoList.SectorScanned = true
			TCFT3.CargoList.UpdateCargoList()
		end
	--end
	
end

TCFT3.CargoList.Refresh = function()
	if(targetless) then targetless.api.radarlock = true end --What does this do?
	TCFT3.CargoList.UserSelectedItem = false
	TCFT3.CargoList.ItemList:clear()
	TCFT3.CargoList.ItemList.numlin=2
	TCFT3.CargoList.ItemList:setcell(2, 1, "  Updating list, please wait...")
	gkinterface.GKProcessCommand("RadarNone")
	TCFT3.CargoList.Timer:Kill()
	TCFT3.CargoList.NumCU = 0
	TCFT3.CargoList.Active = true
	TCFT3.CargoList.ScanNext()
end

TCFT3.CargoList.UpdateCargoList = function(item)
	if (TCFT3.CargoList.ItemList:numitems()>0) then
		TCFT3.CargoList.ItemList:update()
	else
		TCFT3.CargoList.ItemList.numlin=2
		TCFT3.CargoList.ItemList:setcell(2, 1, "  No Cargo found.")
	end
	TCFT3.CargoList.status.value = TCFT3.colors.NORMAL .. TCFT3.CargoList.ItemList:numitems() .. " items (" .. TCFT3.CargoList.NumCU .. " cu)"
end

TCFT3.CargoList.EventSectorChanged = function()
	TCFT3.CargoList.SectorScanned = false
end
